package gregapi.cover.covers;

import static gregapi.data.CS.F;
import static gregapi.data.CS.PIXELS_NEG;
import static gregapi.data.CS.PIXELS_POS;
import static gregapi.data.CS.T;
import gregapi.cover.CoverData;
import gregapi.old.Textures;
import gregapi.render.BlockTextureDefault;
import gregapi.render.BlockTextureMulti;
import gregapi.render.ITexture;
import gregapi.tileentity.machines.ITileEntitySwitchableMode;
import gregapi.util.UT;
import net.minecraft.entity.Entity;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 */
public class CoverSelectorManual extends AbstractCoverAttachmentSelector {
	@Override public boolean interceptCoverPlacement(byte aCoverSide, CoverData aData, Entity aPlayer) {return !(aData.mTileEntity instanceof ITileEntitySwitchableMode);}
	
	@Override
	public void onCoverPlaced(byte aSide, CoverData aData, Entity aPlayer, ItemStack aCover) {
		super.onCoverPlaced(aSide, aData, aPlayer, aCover);
		if (aData.mTileEntity instanceof ITileEntitySwitchableMode) aData.visual(aSide, ((ITileEntitySwitchableMode)aData.mTileEntity).getStateMode());
	}
	
	@Override
	public void onTickPre(byte aSide, CoverData aData, long aTimer, boolean aIsServerSide, boolean aReceivedBlockUpdate, boolean aReceivedInventoryUpdate) {
		if (aIsServerSide && aData.mTileEntity instanceof ITileEntitySwitchableMode) aData.visual(aSide, ((ITileEntitySwitchableMode)aData.mTileEntity).setStateMode(UT.Code.bind4(aData.mVisuals[aSide])));
	}
	
	@Override
	public boolean onCoverClickedRight(byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {
		if (aSide == aSideClicked && aData.mTileEntity instanceof ITileEntitySwitchableMode) {
			boolean rReturn = F;
			byte tMode = UT.Code.bind4(aData.mVisuals[aSide]);
			float[] tCoords = UT.Code.getFacingCoordsClicked(aSideClicked, aHitX, aHitY, aHitZ);
			if (tCoords[1] >= PIXELS_POS[1] && tCoords[1] <= PIXELS_POS[4]) {
				if (tCoords[0] >= PIXELS_POS[1] && tCoords[0] <= PIXELS_POS[4]) {
					tMode--;
					if (tMode < 0) tMode = 15;
					rReturn = T;
				} else
				if (tCoords[0] >= PIXELS_NEG[4] && tCoords[0] <= PIXELS_NEG[1]) {
					tMode++;
					if (tMode > 15) tMode = 0;
					rReturn = T;
				}
			} else
			if (tCoords[1] >= PIXELS_NEG[7] && tCoords[1] <= PIXELS_NEG[4]) {
				if (tCoords[0] >= PIXELS_POS[2] && tCoords[0] <= PIXELS_NEG[2]) {
					if (tCoords[0] <= PIXELS_POS[5]) {
						tMode ^= 8;
					} else
					if (tCoords[0] <= PIXELS_POS[8]) {
						tMode ^= 4;
					} else
					if (tCoords[0] <= PIXELS_NEG[5]) {
						tMode ^= 2;
					} else {
						tMode ^= 1;
					}
					rReturn = T;
				}
			}
			if (aData.mTileEntity.isServerSide()) aData.visual(aSide, tMode);
			return rReturn;
		}
		return F;
	}
	
	@Override public ITexture getCoverTextureSurface(byte aSide, CoverData aData) {return BlockTextureMulti.get(sTexturesBase, sTextures[UT.Code.bind4(aData.mVisuals[aSide])]);}
	@Override public ITexture getCoverTextureAttachment(byte aSide, CoverData aData, byte aTextureSide) {return aSide != aTextureSide ? sTextureBackground : BlockTextureMulti.get(sTextureBackground, getCoverTextureSurface(aSide, aData));}
	@Override public ITexture getCoverTextureHolder(byte aSide, CoverData aData, byte aTextureSide) {return sTextureBackground;}
	@Override public boolean needsVisualsSaved(byte aSide, CoverData aData) {return T;}
	
	public static final ITexture[] sTextures = new ITexture[] {
		  BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/0"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/1"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/2"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/3"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/4"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/5"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/6"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/7"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/8"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/9"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/10"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/11"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/12"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/13"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/14"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/15"), T)
	};
	
	public static final ITexture sTexturesBase = BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/underlay"));
	public static final ITexture sTextureBackground = BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/manualselector/base"));
}